/*
 *  mruby => TECS brige
 *  
 *   Copyright (C) 2008-2012 by TOPPERS Project
 *--
 *   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *   ܥեȥѤΤޤࡥʲƱˤѡʣ
 *   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *       ˴ޤޤƤ뤳ȡ
 *   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *       ѤǤǺۤˤϡۤȼɥȡ
 *       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *       ̵ݾڵǺܤ뤳ȡ
 *   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *       ѤǤʤǺۤˤϡΤ줫ξ
 *       ȡ
 *     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *         𤹤뤳ȡ
 *   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *       դ뤳ȡ
 *  
 *   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *   TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *   ФŬޤơʤݾڤԤʤޤܥեȥ
 *   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *   Ǥʤ
 *  
 *   $Id: TECSStruct.h 1948 2013-04-30 02:22:04Z okuma-top $ 
 */

#ifndef TECSStruct_h__
#define TECSStruct_h__

#define MEMBER_GET_SET_INT( TAG, MEMBER, Type, TYPE )					\
	static mrb_value													\
	Struct_ ## TAG ## _ ## MEMBER ## _aget(mrb_state *mrb, mrb_value self)	\
	{																	\
		struct TAG *st = DATA_PTR( self );								\
		TYPE ## _t	val;												\
																		\
		val = st->MEMBER;												\
		VALCHECK_MRB_ ## Type( mrb, val );								\
		return mrb_fixnum_value( val );									\
	}																	\
																		\
	static mrb_value													\
	Struct_ ## TAG ## _ ## MEMBER ## _aset(mrb_state *mrb, mrb_value self)	\
	{																	\
		struct TAG *st = DATA_PTR( self );								\
		mrb_int	val;													\
																		\
		mrb_get_args(mrb, "i", &val );									\
																		\
		VALCHECK_ ## Type ( mrb, val );									\
		st->MEMBER = val;												\
																		\
		return self;													\
	}

#define MEMBER_GET_SET_FLOAT( TAG, MEMBER )								\
	static mrb_value													\
	Struct_ ## TAG ## _ ## MEMBER ## _aget(mrb_state *mrb, mrb_value self)	\
	{																	\
		struct TAG *st = DATA_PTR( self );								\
																		\
		return mrb_float_value( st->MEMBER );								\
	}																	\
																		\
	static mrb_value													\
	Struct_ ## TAG ## _ ## MEMBER ## _aset(mrb_state *mrb, mrb_value self)	\
	{																	\
		struct TAG *st = DATA_PTR( self );								\
		mrb_float	val;												\
																		\
		mrb_get_args(mrb, "f", &val );									\
																		\
		st->MEMBER = val;												\
																		\
		return self;													\
	}

////  define Struct class ////
#define STRUCT_CLASS( TAG )												\
																		\
	static void															\
	Struct ## TAG ## Body_free( mrb_state *mrb, void *p )				\
	{																	\
		(void)mrb_free( mrb, p );										\
	}																	\
																		\
	struct mrb_data_type Struct ## TAG ## Body_mrb_data_type =			\
		{																\
			"TECS::Struct" #TAG,										\
			Struct ## TAG ## Body_free									\
		};																\
																		\
	static mrb_value													\
	Struct_ ## TAG ## _initialize( mrb_state *mrb, mrb_value self)		\
	{																	\
		mrb_int	length;													\
		struct  TAG *structBody;										\
																		\
		DATA_TYPE( self ) = &Struct ## TAG ## Body_mrb_data_type;		\
		DATA_PTR( self ) = mrb_malloc(mrb, sizeof(struct TAG)); 		\
						 												\
		return self;													\
	}

#define  STRUCT_INIT_BEGIN( TAG )										\
	struct RClass *														\
	tecs_init_Struct_## TAG(mrb_state *mrb, struct RClass *TECS)		\
	{																	\
		struct RClass *a;												\
																		\
		a = mrb_define_class_under(mrb, TECS, "Struct" #TAG, mrb->object_class); \
		MRB_SET_INSTANCE_TT(a, MRB_TT_DATA);							\
																		\
		mrb_define_method(mrb, a, "initialize", Struct_ ## TAG ## _initialize,            ARGS_NONE());

#define  STRUCT_INIT_MEMBER( TAG, MEMBER )								\
		mrb_define_method(mrb, a, #MEMBER,      Struct_ ## TAG ## _ ## MEMBER ## _aget,   ARGS_NONE()); \
		mrb_define_method(mrb, a, #MEMBER "=",  Struct_ ## TAG ## _ ## MEMBER ## _aset,   ARGS_REQ(1));


#define  STRUCT_INIT_END( TAG )											\
	}

#define CHECK_STRUCT( tag, value )										\
	do {																\
		if( mrb_type(value) != MRB_TT_DATA								\
			|| DATA_TYPE( value ) == 0									\
			|| strcmp( DATA_TYPE( value )->struct_name, "TECS::Struct" #tag ) ) \
			mrb_raise(mrb, E_TYPE_ERROR, "not Struct or tag mismatch"); \
	}while(0)

#endif /* TECSStruct_h__ */
