# -*- coding: euc-jp -*-
#
#  TECS Generator Cell-type plugin
#      for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2013 by TOPPERS Project TECS-WG
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id
#++

#== celltype ץ饰ζ̤οƥ饹
class ATK1ResourcePlugin < CelltypePlugin
#@celltype:: Celltype
#@option:: String     :ץʸ

  #signature::     Celltype        ˥ʥ󥹥󥹡
  def initialize( celltype, option )
    super
  end

  #===  CDL ե
  #      typedef, signature, celltype, cell Υɤ
  #      ʣƤϤʤʤ
  #      ǤƤϽϤʤȡ
  #      ⤷Ʊ̾ import ˤꡢʣ򤱤뤳ȡ
  #file::        FILE       ե
#  def gen_cdl_file file
#  end

  def new_cell cell
  end

  #===  ؿ(C)
  #     Υ᥽åɤ̤ξ硢ͥ졼ϼؿΥƥץ졼Ȥ
  #     Υ᥽åɤѤߤξ硢ʥƥץ졼ȤǤϤʤѹɬפΤʤ˥륿ץɤ
  #file::           FILE        ե
  #b_singleton::    bool        true if singleton
  #ct_name::        Symbol
  #global_ct_name:: string
  #sig_name::       string
  #ep_name::        string
  #func_name::      string
  #func_global_name:: string
  #func_type::      class derived from Type
#  def gen_ep_func_body( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )
#  end

  def gen_factory file

  file2 = CFile.open( "#{$gen}/RESOURCE_tecsgen.oil", "w" )
  file3 = CFile.open( "#{$gen}/#{@celltype.get_name}_factory.h", "w" )

  # RESOURCE
  @celltype.get_cell_list.each { |cell|

    if cell.is_generate?

      str = cell.get_name

      if str.to_s == "RES_SCHEDULER" then

        cell.set_specified_id( 1 )

      else

        file3.print "DeclareResource( #{cell.get_name} );\n"

        file2.print "\tRESOURCE #{cell.get_name} {\n"

        # PROPERTY
        join = cell.get_join_list.get_item( :property )
        if join then
          str = join.get_rhs.to_s.gsub(/^"(.*)"$/, '\1')

          if str == "LINKED" then
            file2.print "\t\tRESOURCEPROPERTY = #{str} {\n"
            join2 = cell.get_join_list.get_item( :linkedResource )
            str2 = join2.get_rhs.to_s.gsub(/^"(.*)"$/, '\1')
            file2.print "\t\t\tLINKEDRESOURCE = #{str2};\n"
            file2.print "\t\t};\n"
          else
            file2.print "\t\tRESOURCEPROPERTY = #{str};\n"
          end
        end

        file2.print "\t};\n"
        file2.print "\n"

      end

    end
  }

  file2.close
  file3.close

  end

end
