#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2013 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: in_exerb.rb 1943 2013-04-30 01:37:51Z okuma-top $
#++

# exerb ǤǺǽɤߤޤե
# Υե뤫 generate.rb ɤߤޤ

$IN_EXERB=true

# ѿ exerb ǤΤ
$path = ENV[ 'PATH' ]

#=== cygwin Υѥ Windows ѥѴ
# cygpath ޥɤõơĤѴ
# ѴǤʤäޤѴΥѥĤʤ硢default ֤
def cygpath( path, default = nil )
  if ! $IN_EXERB then
    return default
  end
  if File.exist? path then
    return default
  end

  found = false
  $path.split( ";" ).each{ |path2|
    cygpath_path = "#{path2}\\cygpath.exe"
    if File.exist?( cygpath_path )  then
      path3 = nil
      dbgPrint "in_exerb: cygpath: found\n"
      IO.popen( "cygpath -m #{path}", "r"){ |io|
        path3 = io.gets.chomp!
      }
      dbgPrint "in_exerb: cygpath: '#{path}' => '#{path3}'\n"
      File.stat( path3.to_s )

      if File.exist?( path3 )
        dbgPrint "in_exerb: cygpath: '#{path3}' found\n"
        return path3
      else
        break
      end
    end
  }
  dbgPrint "cygpath '#{path}' not found\n"
  return default
end

# gcc Υѥꤹ
#  cygwin ΤСǤ gcc  gcc-3.exe ޤ gcc-4.exe ؤΥܥå󥯤ȤʤäƤ
#  exerb ǤǤϥܥå󥯤éʤ gcc  exe õ
#  cygwin Υ󥯤ϡƥ°դ졢ޥɥץץȾǤ dir /A:S ꤷʤɽʤ
#  (cygwin ΥСǼۤʤ뤫⤷ʤ)
#  եƬ2ХȤɽФ PE եޥåȤΥޥå˰פ뤫Ĵ٤
$gcc = "gcc"
$path.split( ";" ).each{ |path|
  found = false
  [ "gcc.exe", "gcc-3.exe", "gcc-4.exe" ].each{ |gcc|
    gcc_path = "#{path}\\#{gcc}"
    if File.exist?( gcc_path )  then
      begin
        magic = File.read( gcc_path, 2 )
        if magic == "MZ"                  # ޥåå
          $gcc = gcc
          found = true
          break
        end
      rescue
        # magic ɽФ˼ԡ̵
      end
    end
  }
  break if found
}

# cpp ޥɤꤹ
$cpp = "#{$gcc} -E -D TECS"

# exerb  TECS ͥ졼μ¹Ԥ򳫻
require "tecsgen.rb"
