# -*- coding: euc-jp -*-
#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2013 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: plugin.rb 1951 2013-05-01 08:48:13Z okuma-top $
#++

#== class ⥸塼
# ThroughPlugin, SignaturePlugin, CelltypePlugin  include 
class Plugin < Node
#@error_backlog:: [msg1, msg2, ... ]   @locale ꤵȯ顼

  PluginArgProc = {
    "silent"  => Proc.new { |obj,rhs| obj.set_silent rhs },
  }

  def initialize
    super
    @b_silent = false
    @locale = nil       # set_locale ƤӽФޤ nil Ȥʤ
    @error_backlog = []
  end

  #=== Plugin#cdl_error
  # set_locale ƤӽФޤ @error_backlog ¸α
  def cdl_error *arg
    if @locale then
      Generator.error2( @locale, *arg )
    else
      @error_backlog << arg
    end
  end

  #=== locale ꤹ
  # Node  initialize  locale ꤹ뤬plugin  parse Ȥ
  # ۤʤ륿ߥ new 뤿ᡢlocale ꤹ
  # Υ᥽åɤ2ٸƤӽФ @error_backlog Υ顼2ٽϤƤޤ
  def set_locale locale
    @locale = locale
    @error_backlog.each { |arg|
      Generator.error2( locale, *arg )
    }
  end

### ̣ʳǸƤӽФ᥽å ###
  #===  CDL ե
  #      typedef, signature, celltype, cell Υɤ
  #      ʣƤϤʤʤ
  #      ǤƤϽϤʤȡ
  #      ⤷Ʊ̾ import ˤꡢʣ򤱤뤳ȡ
  #file::        FILE       ե
  def gen_cdl_file file
  end


### ʳǸƤӽФ᥽å ###
  #=== ץ饰 gen_ep_func 󶡤뤫
  # gen_ep_func     ƥץ졼ȤǤϤʤ륿ץ(tCelltype.c) 
  # gen_ep_func ̤  ƥץ졼(tCelltype_templ.c)
  def gen_ep_func?
    self.class.method_defined?( :gen_ep_func_body )
  end

  #===  ؿ(C)
  #     ץ饰ξ硢ѹɬפΤʤ륿ץɤ
  #     Υ᥽åɤ̤ǤСץ饰ϥ륿ץɤʤ (̤̾ƥץ졼Ȥ)
  #      gen_cdl_file 줿륿פФƸƤӽФ
  #file::           FILE        ե (tCelltype.c)
  #b_singleton::    bool        true if singleton
  #ct_name::        Symbol
  #global_ct_name:: string
  #sig_name::       string
  #ep_name::        string
  #func_name::      string
  #func_global_name:: string
  #func_type::      class derived from Type
#  def gen_ep_func_body( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )
#  end

  #===  ؿ preamble (C)
  #     ɬפʤ preamble ˽Ϥ
  #      gen_cdl_file Ǥ줿륿פФƸƤӽФ
  #file::           FILE        ե
  #b_singleton::    bool        true if singleton
  #ct_name::        Symbol
  #global_ct_name:: string
  def gen_preamble( file, b_singleton, ct_name, global_ct_name )
    # ǥեȤǤϲϤʤ
  end

  #===  ؿ postamble (C)
  #     ɬפʤ postamble ˽Ϥ
  #      gen_cdl_file 줿륿פФƸƤӽФ
  #file::           FILE        ե
  #b_singleton::    bool        true if singleton
  #ct_name::        Symbol
  #global_ct_name:: string
  def gen_postamble( file, b_singleton, ct_name, global_ct_name )
    # ǥեȤǤϲϤʤ
  end

  #=== gen_cdl_file 줿륿פ˿뤬줿
  # ɤΥ륿פ cell.get_celltype ʬ
  #
  #file::           FILE        ե
  #b_singleton::    bool        true if singleton
  #ct_name::        Symbol
  #global_ct_name:: string
  def new_cell cell
    # ǥեȤǤϲ⤷ʤ
  end

### ץ饰β ###
  def parse_plugin_arg
    arg = @plugin_arg_str.dup

    # Ԥä
    arg.gsub!( /\\\n/, "" )

    while arg != ""

      # ζɤФ
      arg.sub!( /\A\s*(?:\\\n)*\s*(.*)/, '\1')

      #  ̻Ҽ
      if arg =~ /\A[a-zA-Z_]\w*/ then
        ident = $~
        arg = $'
      else
        cdl_error( "P1001 plugin arg: cannot find identifier in $1" , arg )
        return
      end
      
      # ζɤФ
      arg.sub!( /\A\s*(?:\\\n)*\s*(.*)/, '\1')

      if arg =~ /=/ then
        arg = $'
      else
        cdl_error( "P1002 plugin arg: expecting \'=\' not \'$1\'" , arg )
        return
      end

      # ζɤФ
      arg.sub!( /\A\s*(?:\\\n)*\s*(.*)/, '\1')

      # ʸ
      if arg =~ /\A\\"(.*?)\\"\s*,/ then      # \"  \" ǰϤޤƤ
        rhs = $1
        remain = $'
      elsif arg =~ /\A%(.*?)%\s*,/ then      # %   % ǰϤޤƤ
        rhs = $1
        remain = $'
      elsif arg =~ /\A!(.*?)!\s*,/ then    # $   $ ǰϤޤƤ
        rhs = $1
        remain = $'
      elsif arg =~ /\A'(.*?)'\s*,/ then    # $   $ ǰϤޤƤ
        rhs = $1
        remain = $'
      elsif  arg =~ /\A\\"(.*?)\\"\s*,/ then  # || ˤ [,$] ˤǤʤä
        rhs = $1
        remain = $'
      # elsif arg =~ /\A(.*?)\s*$/ then
      elsif arg =~ /\A\\"(.*?)\\"\s*\z/ then      # \"  \" ǰϤޤƤ
        rhs = $1
        remain = $'
      elsif arg =~ /\A%(.*?)%\s*\z/ then      # %   % ǰϤޤƤ
        rhs = $1
        remain = $'
      elsif arg =~ /\A!(.*?)!\s*\z/ then    # $   $ ǰϤޤƤ
        rhs = $1
        remain = $'
      elsif arg =~ /\A'(.*?)'\s*\z/ then    # $   $ ǰϤޤƤ
        rhs = $1
        remain = $'
      elsif  arg =~ /\A\\"(.*?)\\"\s*\z/ then  # || ˤ [,$] ˤǤʤä
        rhs = $1
        remain = $'
      elsif arg =~ /\A(.*?),/ then
        rhs = $1
        remain = $'
        # ζɤФ
        rhs.sub!( /\A\s*(.*)\s*\z/, '\1')
      elsif arg =~ /\A(.*?)\s*\z/ then
        rhs = $1
        remain = $'
      else
        cdl_error( "P1003 plugin arg: unexpected $1" , arg )
        return
      end

      # 0ʸʸ to_sym 㳰ȯΤǶʸȤ
      if rhs == "" then
        rhs = " "
      end

      arg = remain         # arg λĤʬ
      arg.sub!( /\A\s*(?:\\\n)*\s*(.*)/, '\1')      # ζɤФ

      # \ 򳰤
      rhs = rhs.gsub( /\\(.)/, "\\1" )   #  $' Ѥ뤳Ȥա
      # print "parse_plugin_arg:  #{ident} #{rhs}\n"
      @plugin_arg_list[ ident ] = rhs

      check_plugin_arg( ident, rhs )
    end
    # @plugin_arg_list.each{|i,r|  print "ident: #{i}  rhs: #{r}\n" }
  end

  #=== ץ饰å
  # @plugin_arg_check_proc_tab ˽äƥץ饰å
  # Ťˡҥ饹ǥС饤ɤ̻Ҥå
  #ident:: string: ̻
  #rhs:: string: ʸ
  def check_plugin_arg( ident, rhs )

    dbgPrint "check_plugin_arg: #{ident} #{rhs.to_str}\n"
    proc = nil
    if @plugin_arg_check_proc_tab  then
      proc = @plugin_arg_check_proc_tab[ident.to_s]
    end
    if proc == nil then
      proc = PluginArgProc[ ident.to_s ]
    end
    if proc.instance_of? Proc then
      dbgPrint "calling: #{self.class.name}.#{proc.to_s}\n"
      proc.call( self, rhs )
    else
      params = ""
      delim = ""
      @plugin_arg_check_proc_tab.each{ |j,p|
        params = "#{params}#{delim}#{j}"
        delim = ", "
      }
      cdl_error( "P1004 $1: unknown plugin argument\'s identifier\n  $2 are acceptible for RPCPlugin." , ident, params )
    end
  end

  #=== ץ饰Υå
  def print_msg( msg )
    if @b_silent == true then
      return
    end
    print msg
  end

  #=== ץ饰 silent
  def set_silent rhs
    if rhs == "true" || rhs == nil then
      @b_silent = true
    end
  end
end

#== ʸ EUC ϥե convert 
# tecsgen Υɤ EUC ǵҤƤ
# 򡢽ϥեʸɤѴƽϤ
#
# generate.rb ǽϤΤ message.rb ѴƤ
# generate.rb ǽϤΤ APPFile 饹ѤƤ
# mikan: CFile ǽϤΤ factory ɵǤʤ (cdl եξ硢ɵǤƤ̣ʤ)
class CFile
  def self.open( path, mode )
    CFile.new( path, mode )
  end

  def initialize( path, mode )
    if $b_no_kcode then 
      mode += ":" + $Ruby19_File_Encode
    end
    @file = File.open( path, mode )
  end

  def print str
    if $b_no_kcode && $KCONV_CONSOLE == Kconv::BINARY then 
      @file.print( str )
    else
      @file.print( str.kconv( $KCONV_CDL, $KCONV_TECSGEN ) )
    end
  end

  def puts str
    if $b_no_kcode && $KCONV_CONSOLE == Kconv::BINARY then 
      @file.print( str )
    else
      @file.print( str.kconv( $KCONV_CDL, $KCONV_TECSGEN ) )
    end
    @file.print( "\n" )
  end

  def printf( format, *arg )
    if $b_no_kcode && $KCONV_CONSOLE == Kconv::BINARY then 
      @file.print( sprintf( format, *arg ) )
    else
      @file.print( sprintf( format, *arg ).kconv( $KCONV_CDL, $KCONV_TECSGEN ) )
    end
  end

  def close
    @file.close
  end
end
