# -*- coding: euc-jp -*-
#
#  TECS Generator Cell-type plugin
#      for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2013 by TOPPERS Project TECS-WG
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id
#++

#== ATK1 Event celltype ץ饰󥯥饹
class ATK1EventPlugin < CelltypePlugin
#@@instancies:: []     :η
@@instancies = []

  #===  
  #      ƤΥμΤ̣ϸ˻Ȥɬפ뤿
  #       singleton  instancies ˳Ǽ
  #signature::     Celltype        ˥ʥ󥹥󥹡
  def initialize( celltype, option )
    super
    @@instancies << self
  end

  #===  cell
  def new_cell cell
  end

  #===  ̣ϼ¹ԸΥ
  def self.gen_post_code file

    @@instancies.each { |inst|
      inst.gen_oil_code file
    }

  end

  #===  OILե
  def gen_oil_code file

    file2 = CFile.open( "#{$gen}/EVENT_tecsgen.oil", "w" )

    whole_mask = 0

    # EVENT
    @celltype.get_cell_list.each { |cell|

#      if cell.is_generate?
        join = cell.get_join_list.get_item( :mask )

        # AUTO type search and change to zero
        if join then
          #mask_bit = join.get_rhs.to_s.eval_cnst( nil )
          mask_bit = join.get_rhs.to_s.to_i
          mask_str = join.get_rhs.to_s
          if mask_str == "AUTO" then
            new_rhs = Expression.create_integer_constant( 32, @locale )
            join.change_rhs new_rhs
          else
            mask_pattern = 1 << mask_bit
            whole_mask |= mask_pattern
          end
        else
          new_rhs = Expression.create_integer_constant( 32, @locale )
          join = Join.new( :mask, nil, new_rhs )
          cell.new_join(join)
        end

#        file2.print "\t /* working #{join.get_rhs.to_s} */\n"
#      end

    }

    mask_count = 0;
    mask_place = 0;

    @celltype.get_cell_list.each { |cell|

#      if cell.is_generate?
        # bit place to mask pattern
        file2.print "\tEVENT #{cell.get_name} {\n"
        join = cell.get_join_list.get_item( :mask )
        if join then
          mask_bit = join.get_rhs.to_s.to_i
          if mask_bit == 32 then
            while 1
    p("mask_count, current_mask")
    p mask_count
              current_mask = (1 << mask_count)
    p current_mask
              if 0 == whole_mask & current_mask
                new_rhs = Expression.create_integer_constant( current_mask, @locale )
                join.change_rhs new_rhs
                whole_mask = whole_mask | current_mask
                mask_place = mask_count
                break
              end
              if current_mask >= 0x8000
                mask_place = 0
                break
              end
              mask_count = mask_count + 1
            end
          else
            mask_place = join.get_rhs.to_s.to_i
            current_mask = 1 << mask_place
            new_rhs = Expression.create_integer_constant( current_mask, @locale )
            join.change_rhs new_rhs
          end
          file2.print "\t\tMASK = #{mask_place.to_s};\n"
        end

        file2.print "\t};\n"
        file2.print "\n"

#      end

    }

    file2.close

  end

end

