# -*- coding: euc-jp -*-
#
#  mruby => TECS bridge
#  
#   Copyright (C) 2008-2013 by TOPPERS Project
#
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: Mruby2CBridgePlugin.rb 1951 2013-05-01 08:48:13Z okuma-top $
#

class Mruby2CBridgePlugin < SignaturePlugin
  @@signature_list = { }

  def initialize( signature, option )
    super

    @celltype_name = :"t#{@signature.get_global_name}"
    @class_name = :"T#{@signature.get_global_name}"

    parse_plugin_arg
  end

  def gen_cdl_file( file )
    if( @@signature_list.length == 0 )then
      print_msg "  Mruby2CBridgePlugin: [initialize function] 'void initializeBridge( mrb_state *mrb )' must be called from VM.\n"
      c2tecs = "generate( C2TECSBridgePlugin, nMruby::sInitializeBridge, \"silent=true\" );\n"
    end

    if @@signature_list[ @signature.get_global_name ] then
      @@signature_list[ @signature.get_global_name ] << self
      cdl_warning( "MRCW001 signature '$1' duplicate. ignored current one", @signature.get_namespace_path )
      return
    end

    @@signature_list[ @signature.get_global_name ] = [self]
    print_msg "  Mruby2CBridgePlugin: [object creattion]    object = TECS::#{@class_name}.new( 'C#{@signature.get_global_name}' )\n"
    print_msg "  Mruby2CBridgePlugin: [function call]       result = object.function( params )  # substitute 'function' and params \n"

    cf = CFile.open( "#{$gen}/Mruby2C_tsInitializerBridge.cdl", "w")
    cf.print <<EOT
cell nC2TECS::tnMruby_sInitializeBridge C2TECS_tsInitializeBridge{
    cCall = VM_TECSInitializer.eInitialize;
};
EOT
    cf.close

    file.print <<EOT
generate( MrubyBridgePlugin, #{@signature.get_namespace_path}, "silent=true" );
generate( TECS2CBridgePlugin, #{@signature.get_namespace_path}, "silent=true" );
#{c2tecs}
cell nMruby::t#{@signature.get_name} C#{@signature.get_name}{
    cTECS = TECS2C_#{@signature.get_name}.eEnt;
};
cell nTECS2C::t#{@signature.get_name} TECS2C_#{@signature.get_name}{};

import( "Mruby2C_tsInitializerBridge.cdl" );
EOT

  end
end
