# -*- coding: euc-jp -*-
#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2013 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: OpaqueMarshalerPlugin.rb 1935 2013-03-31 14:38:14Z okuma-top $
#++

#== OpaqueMarshaler
# OpaqueRPC ѤΥޡ顢ޡ饻륿פ륷˥ץ饰

require_tecsgen_lib "lib/GenOpaqueMarshaler.rb"
require_tecsgen_lib "lib/GenParamCopy.rb"

class OpaqueMarshalerPlugin < SignaturePlugin

  OpaqueMarshalerPluginArgProc = { }

  include GenOpaqueMarshaler
  include GenParamCopy

  def initialize( signature, option )
    super
    @b_noClientSemaphore = false
    @noServerChannelOpenerCode = true
    initialize_opaque_marshaler

    @plugin_arg_check_proc_tab = OpaqueMarshalerPluginArgProc
    parse_plugin_arg
    # check_PPAllocator
    if @signature.need_PPAllocator?(true) then
      @PPAllocatorSize = 1    # PPAllocatorɬͭΤ (ϻȤʤ)
      necessity = "Necessary"
    else
      necessity = "Unnecessary"
    end

    print "OpaqueMarshalerPlugin: signature=#{signature.get_namespace_path}, PPAllocator=#{necessity}\n"
  end

  def gen_cdl_file file
    gen_marshaler_celltype
    file.print <<EOT
import( "#{@marshaler_celltype_file_name}" );
EOT
  end

  def subst_name( val )
    return :"_"
    # return nil
  end

end
